/**
 * Eine Praesentation (View) eines Labyrinths in 3D mit
 * einem Dialogfenster als Steuerung.
 * 
 * @author Bernd Gramlich 
 * @version 2013-02-05
 */
public class View3DmitDialogfenster implements LabyrinthView
{
    /*
     * Meine Labyrinthdarstellung und mein Dialog.
     */
    public Labyrinth3DDarstellung darstellung;
    public Dialogfenster dialog;

    /**
     * Konstruktor.
     * Erzeuge eine quadratische, dreidimensionale Darstellung des
     * Labyrinths mit der genannten breite und ein Dialogfenster.
     * Gib beiden Bestandteilen der View das Model m und den
     * Controller c weiter.
     */
    public View3DmitDialogfenster (LabyrinthModel m, LabyrinthController c, int breite)
    {
        darstellung = new Labyrinth3DDarstellung (m, breite);
        dialog      = new Dialogfenster (m, c);
    }
     
    /**
     * Erlaube dem Benutzer, geradeaus zu gehen.
     * 
     * @param erlaubt Gehen ist genau bei true erlaubt.
     */
    public void erlaubeGehen (boolean erlaubt)
    {
        dialog.erlaubeGehen (erlaubt);
    }
    
    /**
     * Erlaube dem Benutzer, rckwrts zu gehen.
     * 
     * @param erlaubt RckwrtsGehen ist genau bei true erlaubt.
     */
    public void erlaubeGeheRueckwaerts (boolean erlaubt)
    {
        dialog.erlaubeGeheRueckwaerts (erlaubt);
    }
    
    /**
     * Erlaube dem Benutzer, sich im Labyrinth zu bewegen.
     * 
     * @param erlaubt Bewegen ist genau bei true erlaubt.
     */
    public void erlaubeBewegen (boolean erlaubt)
    {
        dialog.erlaubeBewegen (erlaubt);
    }
    
    /**
     * Erlaube dem Benutzer, ein Labyrinth zu laden.
     * 
     * @param erlaubt Laden ist genau bei true erlaubt.
     */
    public void erlaubeLaden (boolean erlaubt)
    {
        dialog.erlaubeLaden (erlaubt);
    }
    
     /**
     * Erlaube dem Benutzer, ein Labyrinth zu speichern. (Falls die
     * View einen entsprechenden Button enthaelt, sollte er
     * aktiviert werden.)
     * 
     * @param erlaubt Speichern ist genau bei true erlaubt.
     */
    public void erlaubeSpeichern (boolean erlaubt)
    {
        dialog.erlaubeSpeichern (erlaubt);
    }
    
    /**
     * Setze die Hellsichtweite (also die Distanz, auf die Farben
     * ihren Echtwert haben) auf die angegebene Weite.
     * 
     * @param weite Die gewuenschte Hellsichtweite.
     */
    public void setzeHellsichtweite (double weite)
    {
        darstellung.setzeHellsichtweite (weite);
    }
}
